/******/ (function(modules) { // webpackBootstrap
/******/ 	// The module cache
/******/ 	var installedModules = {};
/******/
/******/ 	// The require function
/******/ 	function __webpack_require__(moduleId) {
/******/
/******/ 		// Check if module is in cache
/******/ 		if(installedModules[moduleId]) {
/******/ 			return installedModules[moduleId].exports;
/******/ 		}
/******/ 		// Create a new module (and put it into the cache)
/******/ 		var module = installedModules[moduleId] = {
/******/ 			i: moduleId,
/******/ 			l: false,
/******/ 			exports: {}
/******/ 		};
/******/
/******/ 		// Execute the module function
/******/ 		modules[moduleId].call(module.exports, module, module.exports, __webpack_require__);
/******/
/******/ 		// Flag the module as loaded
/******/ 		module.l = true;
/******/
/******/ 		// Return the exports of the module
/******/ 		return module.exports;
/******/ 	}
/******/
/******/
/******/ 	// expose the modules object (__webpack_modules__)
/******/ 	__webpack_require__.m = modules;
/******/
/******/ 	// expose the module cache
/******/ 	__webpack_require__.c = installedModules;
/******/
/******/ 	// identity function for calling harmony imports with the correct context
/******/ 	__webpack_require__.i = function(value) { return value; };
/******/
/******/ 	// define getter function for harmony exports
/******/ 	__webpack_require__.d = function(exports, name, getter) {
/******/ 		if(!__webpack_require__.o(exports, name)) {
/******/ 			Object.defineProperty(exports, name, {
/******/ 				configurable: false,
/******/ 				enumerable: true,
/******/ 				get: getter
/******/ 			});
/******/ 		}
/******/ 	};
/******/
/******/ 	// getDefaultExport function for compatibility with non-harmony modules
/******/ 	__webpack_require__.n = function(module) {
/******/ 		var getter = module && module.__esModule ?
/******/ 			function getDefault() { return module['default']; } :
/******/ 			function getModuleExports() { return module; };
/******/ 		__webpack_require__.d(getter, 'a', getter);
/******/ 		return getter;
/******/ 	};
/******/
/******/ 	// Object.prototype.hasOwnProperty.call
/******/ 	__webpack_require__.o = function(object, property) { return Object.prototype.hasOwnProperty.call(object, property); };
/******/
/******/ 	// __webpack_public_path__
/******/ 	__webpack_require__.p = "";
/******/
/******/ 	// Load entry module and return exports
/******/ 	return __webpack_require__(__webpack_require__.s = 15);
/******/ })
/************************************************************************/
/******/ ([
/* 0 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0_base64_js__ = __webpack_require__(3);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0_base64_js___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_0_base64_js__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1_url_parse__ = __webpack_require__(1);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1_url_parse___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_1_url_parse__);



/* harmony default export */ __webpack_exports__["a"] = (function(rpc) {

    class ActivityStream {
        constructor(streamCreated) {
            this.getId = streamCreated.then(({ streamId }) => streamId);
            this.listeners = {};
            this.closed = false;
        }

        addEventListener(event, fn) {
            if (!this.listeners[event]) {
                this.listeners[event] = [fn];
                this.getId.then(id => {
                    this._runloop(id, event);
                });
            } else {
                this.listeners[event].push(fn);
            }
        }

        _runloop(streamId, event) {
            if (this.closed) {
                return Promise.resolve();
            }
            const listeners = this.listeners[event];
            rpc.pollActivityStream({
                streamId,
                event,
            }).then((events) => {
                events.forEach((evt) => {
                    listeners.forEach((fn) => {
                        try {
                            fn(evt);
                        } catch(e) {
                            console.error('Error in stream event listener', e);
                        }
                    });
                });
            }).then(() => this._runloop(streamId, event));
        }

        close() {
            this.closed = true;
            this.listeners = {};
            this.getId.then(streamId => {
                rpc.closeActivityStream({
                    streamId,
                });
            });
        }
    }

    class Stat {
        constructor(stat) {
            Object.assign(this, stat);
        }

        isDirectory() {
            return this._isDirectory;
        }

        isFile() {
            return this._isFile;
        }
    }

    function cleanPath(path) {
        // standardise path format across platforms
        // replace windows style separators with unix
        const cleanedPath = path.replace(/\\/g, '/');
        if (cleanedPath.startsWith('/')) {
            return cleanedPath.substring(1);
        }
        return cleanedPath;
    }

    return class DatArchive {
        constructor(datUrl) {
            // in some cases a http url might be passed here
            // (e.g. if document.location is used by the page)
            const parts = __WEBPACK_IMPORTED_MODULE_1_url_parse___default()(datUrl);
            if (!parts.host) {
                throw 'Invalid dat:// URL';
            }
            this.url = `dat://${parts.host}`;
        }

        static async create(opts) {
            return rpc.create({ opts }).then(url => new DatArchive(url));
        }

        static async fork(url, opts) {
            return rpc.fork({ url, opts }).then(url => new DatArchive(url));
        }

        static async selectArchive(opts) {
            return rpc.selectArchive({ opts }).then(url => new DatArchive(url));
        }

        static async resolveName(name) {
            return rpc.resolveName({ name });
        }

        async getInfo(opts) {
            return rpc.getInfo({ url: this.url, opts });
        }

        async configure(opts) {
            return rpc.configure({ url: this.url, opts });
        }

        async copy(path, dstPath, opts) {
            return rpc.copy({
                url: this.url,
                path,
                dstPath,
                opts
            });
        }

        async stat(path, opts) {
            const stat = await rpc.stat({
                url: this.url,
                path,
                opts,
            });
            return new Stat(stat);
        }

        async readFile(path, opts) {
            if (opts && opts.encoding === 'binary') {
                // use base64 and then convert back to binary here
                const optsCopy = Object.assign({}, opts);
                optsCopy.encoding = 'base64';
                const b64Contents = await this.readFile(path, optsCopy);
                return __WEBPACK_IMPORTED_MODULE_0_base64_js___default.a.toByteArray(b64Contents).buffer;
            }
            return rpc.readFile({
                url: this.url,
                path,
                opts,
            });
        }

        async readdir(path, opts) {
            const dir = await rpc.readdir({
                url: this.url,
                path,
                opts,
            });
            if (opts && opts.stat) {
                return dir.map(({ name, stat }) => ({ name: cleanPath(name), stat: new Stat(stat)}));
            }
            return dir.map(cleanPath);
        }

        async writeFile(path, data, opts) {
            if ((opts && opts.encoding === 'binary') || data instanceof ArrayBuffer) {
                // convert binary to base64 and write that instead
                const optsCopy = Object.assign({}, opts);
                optsCopy.encoding = 'base64';
                return this.writeFile(path, __WEBPACK_IMPORTED_MODULE_0_base64_js___default.a.fromByteArray(new Uint8Array(data)), optsCopy);
            }
            return rpc.writeFile({
                url: this.url,
                path,
                data,
                opts,
            });
        }

        async mkdir(path) {
            return rpc.mkdir({
                url: this.url,
                path,
            });
        }

        async unlink(path) {
            return rpc.unlink({
                url: this.url,
                path,
            });
        }

        async rmdir(path, opts) {
            return rpc.rmdir({
                url: this.url,
                path,
                opts,
            });
        }

        async rename(oldPath, newPath, opts) {
            return rpc.rename({
                url: this.url,
                oldPath,
                newPath,
                opts,
            });
        }

        async diff(opts) {
            return rpc.diff({
                url: this.url,
                opts,
            });
        }

        async commit() {
            return rpc.commit({
                url: this.url,
            });
        }

        async revert() {
            return rpc.revert({
                url: this.url,
            });
        }

        async history(opts) {
            return rpc.history({
                url: this.url,
                opts,
            });
        }

        async download(path, opts) {
            return rpc.download({
                url: this.url,
                path,
                opts,
            });
        }

        watch(pattern) {
            return this.createFileActivityStream(pattern);
        }

        createFileActivityStream(pattern) {
            return new ActivityStream(rpc.createFileActivityStream({
                url: this.url,
                pattern,
            }));
        }

        createNetworkActivityStream() {
            return new ActivityStream(rpc.createNetworkActivityStream({
                url: this.url,
            }));
        }
    };
});

/***/ }),
/* 1 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";
/* WEBPACK VAR INJECTION */(function(global) {

var required = __webpack_require__(5)
  , qs = __webpack_require__(4)
  , protocolre = /^([a-z][a-z0-9.+-]*:)?(\/\/)?([\S\s]*)/i
  , slashes = /^[A-Za-z][A-Za-z0-9+-.]*:\/\//;

/**
 * These are the parse rules for the URL parser, it informs the parser
 * about:
 *
 * 0. The char it Needs to parse, if it's a string it should be done using
 *    indexOf, RegExp using exec and NaN means set as current value.
 * 1. The property we should set when parsing this value.
 * 2. Indication if it's backwards or forward parsing, when set as number it's
 *    the value of extra chars that should be split off.
 * 3. Inherit from location if non existing in the parser.
 * 4. `toLowerCase` the resulting value.
 */
var rules = [
  ['#', 'hash'],                        // Extract from the back.
  ['?', 'query'],                       // Extract from the back.
  function sanitize(address) {          // Sanitize what is left of the address
    return address.replace('\\', '/');
  },
  ['/', 'pathname'],                    // Extract from the back.
  ['@', 'auth', 1],                     // Extract from the front.
  [NaN, 'host', undefined, 1, 1],       // Set left over value.
  [/:(\d+)$/, 'port', undefined, 1],    // RegExp the back.
  [NaN, 'hostname', undefined, 1, 1]    // Set left over.
];

/**
 * These properties should not be copied or inherited from. This is only needed
 * for all non blob URL's as a blob URL does not include a hash, only the
 * origin.
 *
 * @type {Object}
 * @private
 */
var ignore = { hash: 1, query: 1 };

/**
 * The location object differs when your code is loaded through a normal page,
 * Worker or through a worker using a blob. And with the blobble begins the
 * trouble as the location object will contain the URL of the blob, not the
 * location of the page where our code is loaded in. The actual origin is
 * encoded in the `pathname` so we can thankfully generate a good "default"
 * location from it so we can generate proper relative URL's again.
 *
 * @param {Object|String} loc Optional default location object.
 * @returns {Object} lolcation object.
 * @public
 */
function lolcation(loc) {
  var location = global && global.location || {};
  loc = loc || location;

  var finaldestination = {}
    , type = typeof loc
    , key;

  if ('blob:' === loc.protocol) {
    finaldestination = new Url(unescape(loc.pathname), {});
  } else if ('string' === type) {
    finaldestination = new Url(loc, {});
    for (key in ignore) delete finaldestination[key];
  } else if ('object' === type) {
    for (key in loc) {
      if (key in ignore) continue;
      finaldestination[key] = loc[key];
    }

    if (finaldestination.slashes === undefined) {
      finaldestination.slashes = slashes.test(loc.href);
    }
  }

  return finaldestination;
}

/**
 * @typedef ProtocolExtract
 * @type Object
 * @property {String} protocol Protocol matched in the URL, in lowercase.
 * @property {Boolean} slashes `true` if protocol is followed by "//", else `false`.
 * @property {String} rest Rest of the URL that is not part of the protocol.
 */

/**
 * Extract protocol information from a URL with/without double slash ("//").
 *
 * @param {String} address URL we want to extract from.
 * @return {ProtocolExtract} Extracted information.
 * @private
 */
function extractProtocol(address) {
  var match = protocolre.exec(address);

  return {
    protocol: match[1] ? match[1].toLowerCase() : '',
    slashes: !!match[2],
    rest: match[3]
  };
}

/**
 * Resolve a relative URL pathname against a base URL pathname.
 *
 * @param {String} relative Pathname of the relative URL.
 * @param {String} base Pathname of the base URL.
 * @return {String} Resolved pathname.
 * @private
 */
function resolve(relative, base) {
  var path = (base || '/').split('/').slice(0, -1).concat(relative.split('/'))
    , i = path.length
    , last = path[i - 1]
    , unshift = false
    , up = 0;

  while (i--) {
    if (path[i] === '.') {
      path.splice(i, 1);
    } else if (path[i] === '..') {
      path.splice(i, 1);
      up++;
    } else if (up) {
      if (i === 0) unshift = true;
      path.splice(i, 1);
      up--;
    }
  }

  if (unshift) path.unshift('');
  if (last === '.' || last === '..') path.push('');

  return path.join('/');
}

/**
 * The actual URL instance. Instead of returning an object we've opted-in to
 * create an actual constructor as it's much more memory efficient and
 * faster and it pleases my OCD.
 *
 * It is worth noting that we should not use `URL` as class name to prevent
 * clashes with the global URL instance that got introduced in browsers.
 *
 * @constructor
 * @param {String} address URL we want to parse.
 * @param {Object|String} location Location defaults for relative paths.
 * @param {Boolean|Function} parser Parser for the query string.
 * @private
 */
function Url(address, location, parser) {
  if (!(this instanceof Url)) {
    return new Url(address, location, parser);
  }

  var relative, extracted, parse, instruction, index, key
    , instructions = rules.slice()
    , type = typeof location
    , url = this
    , i = 0;

  //
  // The following if statements allows this module two have compatibility with
  // 2 different API:
  //
  // 1. Node.js's `url.parse` api which accepts a URL, boolean as arguments
  //    where the boolean indicates that the query string should also be parsed.
  //
  // 2. The `URL` interface of the browser which accepts a URL, object as
  //    arguments. The supplied object will be used as default values / fall-back
  //    for relative paths.
  //
  if ('object' !== type && 'string' !== type) {
    parser = location;
    location = null;
  }

  if (parser && 'function' !== typeof parser) parser = qs.parse;

  location = lolcation(location);

  //
  // Extract protocol information before running the instructions.
  //
  extracted = extractProtocol(address || '');
  relative = !extracted.protocol && !extracted.slashes;
  url.slashes = extracted.slashes || relative && location.slashes;
  url.protocol = extracted.protocol || location.protocol || '';
  address = extracted.rest;

  //
  // When the authority component is absent the URL starts with a path
  // component.
  //
  if (!extracted.slashes) instructions[3] = [/(.*)/, 'pathname'];

  for (; i < instructions.length; i++) {
    instruction = instructions[i];

    if (typeof instruction === 'function') {
      address = instruction(address);
      continue;
    }

    parse = instruction[0];
    key = instruction[1];

    if (parse !== parse) {
      url[key] = address;
    } else if ('string' === typeof parse) {
      if (~(index = address.indexOf(parse))) {
        if ('number' === typeof instruction[2]) {
          url[key] = address.slice(0, index);
          address = address.slice(index + instruction[2]);
        } else {
          url[key] = address.slice(index);
          address = address.slice(0, index);
        }
      }
    } else if ((index = parse.exec(address))) {
      url[key] = index[1];
      address = address.slice(0, index.index);
    }

    url[key] = url[key] || (
      relative && instruction[3] ? location[key] || '' : ''
    );

    //
    // Hostname, host and protocol should be lowercased so they can be used to
    // create a proper `origin`.
    //
    if (instruction[4]) url[key] = url[key].toLowerCase();
  }

  //
  // Also parse the supplied query string in to an object. If we're supplied
  // with a custom parser as function use that instead of the default build-in
  // parser.
  //
  if (parser) url.query = parser(url.query);

  //
  // If the URL is relative, resolve the pathname against the base URL.
  //
  if (
      relative
    && location.slashes
    && url.pathname.charAt(0) !== '/'
    && (url.pathname !== '' || location.pathname !== '')
  ) {
    url.pathname = resolve(url.pathname, location.pathname);
  }

  //
  // We should not add port numbers if they are already the default port number
  // for a given protocol. As the host also contains the port number we're going
  // override it with the hostname which contains no port number.
  //
  if (!required(url.port, url.protocol)) {
    url.host = url.hostname;
    url.port = '';
  }

  //
  // Parse down the `auth` for the username and password.
  //
  url.username = url.password = '';
  if (url.auth) {
    instruction = url.auth.split(':');
    url.username = instruction[0] || '';
    url.password = instruction[1] || '';
  }

  url.origin = url.protocol && url.host && url.protocol !== 'file:'
    ? url.protocol +'//'+ url.host
    : 'null';

  //
  // The href is just the compiled result.
  //
  url.href = url.toString();
}

/**
 * This is convenience method for changing properties in the URL instance to
 * insure that they all propagate correctly.
 *
 * @param {String} part          Property we need to adjust.
 * @param {Mixed} value          The newly assigned value.
 * @param {Boolean|Function} fn  When setting the query, it will be the function
 *                               used to parse the query.
 *                               When setting the protocol, double slash will be
 *                               removed from the final url if it is true.
 * @returns {URL} URL instance for chaining.
 * @public
 */
function set(part, value, fn) {
  var url = this;

  switch (part) {
    case 'query':
      if ('string' === typeof value && value.length) {
        value = (fn || qs.parse)(value);
      }

      url[part] = value;
      break;

    case 'port':
      url[part] = value;

      if (!required(value, url.protocol)) {
        url.host = url.hostname;
        url[part] = '';
      } else if (value) {
        url.host = url.hostname +':'+ value;
      }

      break;

    case 'hostname':
      url[part] = value;

      if (url.port) value += ':'+ url.port;
      url.host = value;
      break;

    case 'host':
      url[part] = value;

      if (/:\d+$/.test(value)) {
        value = value.split(':');
        url.port = value.pop();
        url.hostname = value.join(':');
      } else {
        url.hostname = value;
        url.port = '';
      }

      break;

    case 'protocol':
      url.protocol = value.toLowerCase();
      url.slashes = !fn;
      break;

    case 'pathname':
    case 'hash':
      if (value) {
        var char = part === 'pathname' ? '/' : '#';
        url[part] = value.charAt(0) !== char ? char + value : value;
      } else {
        url[part] = value;
      }
      break;

    default:
      url[part] = value;
  }

  for (var i = 0; i < rules.length; i++) {
    var ins = rules[i];

    if (ins[4]) url[ins[1]] = url[ins[1]].toLowerCase();
  }

  url.origin = url.protocol && url.host && url.protocol !== 'file:'
    ? url.protocol +'//'+ url.host
    : 'null';

  url.href = url.toString();

  return url;
}

/**
 * Transform the properties back in to a valid and full URL string.
 *
 * @param {Function} stringify Optional query stringify function.
 * @returns {String} Compiled version of the URL.
 * @public
 */
function toString(stringify) {
  if (!stringify || 'function' !== typeof stringify) stringify = qs.stringify;

  var query
    , url = this
    , protocol = url.protocol;

  if (protocol && protocol.charAt(protocol.length - 1) !== ':') protocol += ':';

  var result = protocol + (url.slashes ? '//' : '');

  if (url.username) {
    result += url.username;
    if (url.password) result += ':'+ url.password;
    result += '@';
  }

  result += url.host + url.pathname;

  query = 'object' === typeof url.query ? stringify(url.query) : url.query;
  if (query) result += '?' !== query.charAt(0) ? '?'+ query : query;

  if (url.hash) result += url.hash;

  return result;
}

Url.prototype = { set: set, toString: toString };

//
// Expose the URL parser and some additional properties that might be useful for
// others or testing.
//
Url.extractProtocol = extractProtocol;
Url.location = lolcation;
Url.qs = qs;

module.exports = Url;

/* WEBPACK VAR INJECTION */}.call(exports, __webpack_require__(2)))

/***/ }),
/* 2 */
/***/ (function(module, exports) {

var g;

// This works in non-strict mode
g = (function() {
	return this;
})();

try {
	// This works if eval is allowed (see CSP)
	g = g || Function("return this")() || (1,eval)("this");
} catch(e) {
	// This works if the window reference is available
	if(typeof window === "object")
		g = window;
}

// g can still be undefined, but nothing to do about it...
// We return undefined, instead of nothing here, so it's
// easier to handle this case. if(!global) { ...}

module.exports = g;


/***/ }),
/* 3 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";


exports.byteLength = byteLength
exports.toByteArray = toByteArray
exports.fromByteArray = fromByteArray

var lookup = []
var revLookup = []
var Arr = typeof Uint8Array !== 'undefined' ? Uint8Array : Array

var code = 'ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/'
for (var i = 0, len = code.length; i < len; ++i) {
  lookup[i] = code[i]
  revLookup[code.charCodeAt(i)] = i
}

// Support decoding URL-safe base64 strings, as Node.js does.
// See: https://en.wikipedia.org/wiki/Base64#URL_applications
revLookup['-'.charCodeAt(0)] = 62
revLookup['_'.charCodeAt(0)] = 63

function getLens (b64) {
  var len = b64.length

  if (len % 4 > 0) {
    throw new Error('Invalid string. Length must be a multiple of 4')
  }

  // Trim off extra bytes after placeholder bytes are found
  // See: https://github.com/beatgammit/base64-js/issues/42
  var validLen = b64.indexOf('=')
  if (validLen === -1) validLen = len

  var placeHoldersLen = validLen === len
    ? 0
    : 4 - (validLen % 4)

  return [validLen, placeHoldersLen]
}

// base64 is 4/3 + up to two characters of the original data
function byteLength (b64) {
  var lens = getLens(b64)
  var validLen = lens[0]
  var placeHoldersLen = lens[1]
  return ((validLen + placeHoldersLen) * 3 / 4) - placeHoldersLen
}

function _byteLength (b64, validLen, placeHoldersLen) {
  return ((validLen + placeHoldersLen) * 3 / 4) - placeHoldersLen
}

function toByteArray (b64) {
  var tmp
  var lens = getLens(b64)
  var validLen = lens[0]
  var placeHoldersLen = lens[1]

  var arr = new Arr(_byteLength(b64, validLen, placeHoldersLen))

  var curByte = 0

  // if there are placeholders, only get up to the last complete 4 chars
  var len = placeHoldersLen > 0
    ? validLen - 4
    : validLen

  for (var i = 0; i < len; i += 4) {
    tmp =
      (revLookup[b64.charCodeAt(i)] << 18) |
      (revLookup[b64.charCodeAt(i + 1)] << 12) |
      (revLookup[b64.charCodeAt(i + 2)] << 6) |
      revLookup[b64.charCodeAt(i + 3)]
    arr[curByte++] = (tmp >> 16) & 0xFF
    arr[curByte++] = (tmp >> 8) & 0xFF
    arr[curByte++] = tmp & 0xFF
  }

  if (placeHoldersLen === 2) {
    tmp =
      (revLookup[b64.charCodeAt(i)] << 2) |
      (revLookup[b64.charCodeAt(i + 1)] >> 4)
    arr[curByte++] = tmp & 0xFF
  }

  if (placeHoldersLen === 1) {
    tmp =
      (revLookup[b64.charCodeAt(i)] << 10) |
      (revLookup[b64.charCodeAt(i + 1)] << 4) |
      (revLookup[b64.charCodeAt(i + 2)] >> 2)
    arr[curByte++] = (tmp >> 8) & 0xFF
    arr[curByte++] = tmp & 0xFF
  }

  return arr
}

function tripletToBase64 (num) {
  return lookup[num >> 18 & 0x3F] +
    lookup[num >> 12 & 0x3F] +
    lookup[num >> 6 & 0x3F] +
    lookup[num & 0x3F]
}

function encodeChunk (uint8, start, end) {
  var tmp
  var output = []
  for (var i = start; i < end; i += 3) {
    tmp =
      ((uint8[i] << 16) & 0xFF0000) +
      ((uint8[i + 1] << 8) & 0xFF00) +
      (uint8[i + 2] & 0xFF)
    output.push(tripletToBase64(tmp))
  }
  return output.join('')
}

function fromByteArray (uint8) {
  var tmp
  var len = uint8.length
  var extraBytes = len % 3 // if we have 1 byte left, pad 2 bytes
  var parts = []
  var maxChunkLength = 16383 // must be multiple of 3

  // go through the array every three bytes, we'll deal with trailing stuff later
  for (var i = 0, len2 = len - extraBytes; i < len2; i += maxChunkLength) {
    parts.push(encodeChunk(
      uint8, i, (i + maxChunkLength) > len2 ? len2 : (i + maxChunkLength)
    ))
  }

  // pad the end with zeros, but make sure to not forget the extra bytes
  if (extraBytes === 1) {
    tmp = uint8[len - 1]
    parts.push(
      lookup[tmp >> 2] +
      lookup[(tmp << 4) & 0x3F] +
      '=='
    )
  } else if (extraBytes === 2) {
    tmp = (uint8[len - 2] << 8) + uint8[len - 1]
    parts.push(
      lookup[tmp >> 10] +
      lookup[(tmp >> 4) & 0x3F] +
      lookup[(tmp << 2) & 0x3F] +
      '='
    )
  }

  return parts.join('')
}


/***/ }),
/* 4 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";


var has = Object.prototype.hasOwnProperty;

/**
 * Decode a URI encoded string.
 *
 * @param {String} input The URI encoded string.
 * @returns {String} The decoded string.
 * @api private
 */
function decode(input) {
  return decodeURIComponent(input.replace(/\+/g, ' '));
}

/**
 * Simple query string parser.
 *
 * @param {String} query The query string that needs to be parsed.
 * @returns {Object}
 * @api public
 */
function querystring(query) {
  var parser = /([^=?&]+)=?([^&]*)/g
    , result = {}
    , part;

  while (part = parser.exec(query)) {
    var key = decode(part[1])
      , value = decode(part[2]);

    //
    // Prevent overriding of existing properties. This ensures that build-in
    // methods like `toString` or __proto__ are not overriden by malicious
    // querystrings.
    //
    if (key in result) continue;
    result[key] = value;
  }

  return result;
}

/**
 * Transform a query string to an object.
 *
 * @param {Object} obj Object that should be transformed.
 * @param {String} prefix Optional prefix.
 * @returns {String}
 * @api public
 */
function querystringify(obj, prefix) {
  prefix = prefix || '';

  var pairs = [];

  //
  // Optionally prefix with a '?' if needed
  //
  if ('string' !== typeof prefix) prefix = '?';

  for (var key in obj) {
    if (has.call(obj, key)) {
      pairs.push(encodeURIComponent(key) +'='+ encodeURIComponent(obj[key]));
    }
  }

  return pairs.length ? prefix + pairs.join('&') : '';
}

//
// Expose the module.
//
exports.stringify = querystringify;
exports.parse = querystring;


/***/ }),
/* 5 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";


/**
 * Check if we're required to add a port number.
 *
 * @see https://url.spec.whatwg.org/#default-port
 * @param {Number|String} port Port number we need to check
 * @param {String} protocol Protocol we need to check against.
 * @returns {Boolean} Is it a default port for the given protocol
 * @api private
 */
module.exports = function required(port, protocol) {
  protocol = protocol.split(':')[0];
  port = +port;

  if (!port) return false;

  switch (protocol) {
    case 'http':
    case 'ws':
    return port !== 80;

    case 'https':
    case 'wss':
    return port !== 443;

    case 'ftp':
    return port !== 21;

    case 'gopher':
    return port !== 70;

    case 'file':
    return false;
  }

  return port !== 0;
};


/***/ }),
/* 6 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (immutable) */ __webpack_exports__["a"] = useNativeBridge;
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__dat_archive__ = __webpack_require__(16);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__common_dat_archive_rpc__ = __webpack_require__(0);



let datArchive = __WEBPACK_IMPORTED_MODULE_0__dat_archive__["a" /* default */];

function useNativeBridge(bridge) {
    datArchive = __webpack_require__.i(__WEBPACK_IMPORTED_MODULE_1__common_dat_archive_rpc__["a" /* default */])(bridge);
}

/* harmony default export */ __webpack_exports__["b"] = ({
    get DatArchive() {
        return datArchive;
    }
});


/***/ }),
/* 7 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return proxyReady; });
/* harmony export (immutable) */ __webpack_exports__["b"] = setGatewayAddress;
/* harmony export (immutable) */ __webpack_exports__["c"] = sendMessageToPAC;
const pacFile = 'pac.js';
const pacFileUrl = browser.extension.getURL(pacFile);
const proxyOnRequestAvailable = !!browser.proxy.onRequest;
const datSites = new Set();
const datUrlMatcher = /^[0-9a-f]{64}$/;
const proxyInfo = {
    type: 'http',
    host: 'localhost',
    port: 3000,
};

// in order to create a valid origin for dat sites we need to 'invent'
// hostnames for them. We can do this via a pac file which proxies requests
// for domains we want to serve over dat to the dat-gateway. This hack allows
// us to create hostnames on the fly.
let proxyReady = proxyOnRequestAvailable ? Promise.resolve() : browser.proxy.register(pacFile);

if (proxyOnRequestAvailable) {
    browser.proxy.onRequest.addListener((details) => {
        const { host } = new URL(details.url);
        if (datSites.has(host) || datUrlMatcher.test(host)) {
            console.log(`loading url over dat: ${details.url} via ${proxyInfo.type}://${proxyInfo.host}:${proxyInfo.port}`);
            return proxyInfo;
        }
    }, { 'urls': ['http://*/*']} );
} else {
    // log messages from the pac file
    browser.runtime.onMessage.addListener((message, sender) => {
        if (sender.url === pacFileUrl) {
            console.log('[PAC]', message);
        }
    });
}

function setGatewayAddress(address) {
    const addressRegex = /(https?):\/\/([^/?:]+)(:[0-9]+)?/;
    let [, type, host, port] = address.match(addressRegex);
    if (!port) {
        port = type === 'https' ? 443 : 80;
    } else {
        port = Number(port.substring(1));
    }
    console.log('update gateway address to', type, host, port);
    sendMessageToPAC({
        action: 'setGateway',
        type,
        host,
        port,
    });
}

function sendMessageToPAC(message) {
    if (proxyOnRequestAvailable) {
        if (message.action === 'add') {
            datSites.add(message.host);
        } else if (message.action === 'remove') {
            datSites.delete(message.host);
        } else if (message.action === 'setGateway') {
            proxyInfo.type = message.type;
            proxyInfo.host = message.host;
            proxyInfo.port = message.port;
        }
    } else {
        browser.runtime.sendMessage(message, { toProxyScript: true });
    }
}

/***/ }),
/* 8 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (immutable) */ __webpack_exports__["a"] = addDatSite;
/* harmony export (immutable) */ __webpack_exports__["c"] = removeDatSite;
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__proxy__ = __webpack_require__(7);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__dat_apis__ = __webpack_require__(6);
/**
 * Handles dat sites (domains mapped to dat addresses).
 */



const datSites = new Set();
/* harmony export (immutable) */ __webpack_exports__["b"] = datSites;


/**
 * Add a site which should be loaded over dat instead of https. Instructs the pac file to proxy
 * requests to this host via the dat-gateway, and to downgrade any requests to https address for 
 * this site, so the proxying can work.
 */
function addDatSite(host) {
    console.log('add dat site', host);
    datSites.add(host);
    __webpack_require__.i(__WEBPACK_IMPORTED_MODULE_0__proxy__["c" /* sendMessageToPAC */])({
        action: 'add',
        host,
    });
    registerDowngradeHandler();
}

function removeDatSite(host) {
    console.log('remove dat site', host);
    datSites.delete(host);
    __webpack_require__.i(__WEBPACK_IMPORTED_MODULE_0__proxy__["c" /* sendMessageToPAC */])({
        action: 'remove',
        host,
    });
    registerDowngradeHandler();
}

function registerDowngradeHandler() {
    browser.webRequest.onBeforeRequest.removeListener(switchToDatProtocol);
    if (datSites.size > 0) {
        browser.webRequest.onBeforeRequest.addListener(switchToDatProtocol, {
            urls: [...datSites].map(host => `https://${host}/*`),
        }, ['blocking']);
    }
}

const requestCtr = new Set();
setInterval(() => {
    requestCtr.clear();
}, 30000);

function switchToDatProtocol(details) {
    // detect a repeated requestId through this handler. This means that the browser is preventing
    // the downgrade. In this case, we redirect to the full dat address to prevent an infinite
    // redirect
    if (requestCtr.has(details.requestId)) {
        const [,, host, path] = details.url.split('/', 4);
        return __WEBPACK_IMPORTED_MODULE_1__dat_apis__["b" /* default */].DatArchive.resolveName(host).then((address) => {
            return {
                redirectUrl: `dat://${address}/${path}`,
            };
        });
    }
    requestCtr.add(details.requestId);
    // downgrade requests to get dat version
    return {
        redirectUrl: details.url.replace('https://', 'http://'),
    };
}


/***/ }),
/* 9 */
/***/ (function(module, exports, __webpack_require__) {

var require;var require;(function(f){if(true){module.exports=f()}else if(typeof define==="function"&&define.amd){define([],f)}else{var g;if(typeof window!=="undefined"){g=window}else if(typeof global!=="undefined"){g=global}else if(typeof self!=="undefined"){g=self}else{g=this}g.Spanan = f()}})(function(){var define,module,exports;return (function e(t,n,r){function s(o,u){if(!n[o]){if(!t[o]){var a=typeof require=="function"&&require;if(!u&&a)return require(o,!0);if(i)return i(o,!0);var f=new Error("Cannot find module '"+o+"'");throw f.code="MODULE_NOT_FOUND",f}var l=n[o]={exports:{}};t[o][0].call(l.exports,function(e){var n=t[o][1][e];return s(n?n:e)},l,l.exports,e,t,n,r)}return n[o].exports}var i=typeof require=="function"&&require;for(var o=0;o<r.length;o++)s(r[o]);return s})({1:[function(require,module,exports){
"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
// eslint-disable-next-line
var has = exports.has = function has(o, p) {
  return Object.prototype.hasOwnProperty.call(o, p);
};
},{}],2:[function(require,module,exports){
'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _server = require('./server');

var _server2 = _interopRequireDefault(_server);

var _uuid = require('./uuid');

var _uuid2 = _interopRequireDefault(_uuid);

var _helpers = require('./helpers');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

// eslint-disable-next-line
var getDefaultLogger = function getDefaultLogger() {
  return console.error.bind(console);
};

var Spanan = function () {
  function Spanan(sendFunction) {
    var _ref = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {},
        errorLogger = _ref.errorLogger;

    _classCallCheck(this, Spanan);

    this.sendFunction = sendFunction;
    this.callbacks = new Map();
    this.errorLogger = errorLogger || getDefaultLogger();
    this.listeners = [this];
  }

  _createClass(Spanan, [{
    key: 'send',
    value: function send(action) {
      for (var _len = arguments.length, args = Array(_len > 1 ? _len - 1 : 0), _key = 1; _key < _len; _key++) {
        args[_key - 1] = arguments[_key];
      }

      var resolver = void 0;
      var rejecter = void 0;
      var id = (0, _uuid2.default)();
      var promise = new Promise(function (resolve, reject) {
        resolver = resolve;
        rejecter = reject;
      });
      this.callbacks.set(id, {
        resolver: resolver,
        rejecter: rejecter
      });
      this.sendFunction({
        action: action,
        args: args,
        uuid: id
      });
      return promise;
    }
  }, {
    key: 'createProxy',
    value: function createProxy() {
      return new Proxy(this, {
        get: function get(target, key) {
          return target.send.bind(target, key);
        }
      });
    }
  }, {
    key: 'dispatch',
    value: function dispatch() {
      var message = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};

      var callback = this.callbacks.get(message.uuid);

      if (!callback) {
        return false;
      }

      if ((0, _helpers.has)(message, 'response')) {
        callback.resolver(message.response);
      } else if ((0, _helpers.has)(message, 'error')) {
        callback.rejecter(message.error);
      } else {
        return false;
      }

      this.callbacks.delete(message.uuid);
      return true;
    }
  }, {
    key: 'handleMessage',
    value: function handleMessage(message) {
      return this.listeners.some(function (listener) {
        try {
          return listener.dispatch(message);
        } catch (e) {
          listener.errorLogger('Spanan dispatch error', e);
          return false;
        }
      });
    }
  }, {
    key: 'export',
    value: function _export(actions) {
      var _this = this;

      var _ref2 = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {},
          filter = _ref2.filter,
          transform = _ref2.transform,
          respond = _ref2.respond,
          respondWithError = _ref2.respondWithError,
          errorLogger = _ref2.errorLogger;

      var server = new _server2.default({
        actions: actions,
        respond: respond,
        respondWithError: respondWithError,
        filter: filter,
        transform: transform,
        errorLogger: errorLogger || getDefaultLogger(),
        onTerminate: function onTerminate() {
          _this.listeners = _this.listeners.filter(function (listener) {
            return listener !== server;
          });
        }
      });

      this.listeners.push(server);

      return server;
    }
  }, {
    key: 'reset',
    value: function reset() {
      this.listeners = [];
    }
  }]);

  return Spanan;
}();

exports.default = Spanan;
},{"./helpers":1,"./server":3,"./uuid":4}],3:[function(require,module,exports){
'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _helpers = require('./helpers');

function _toConsumableArray(arr) { if (Array.isArray(arr)) { for (var i = 0, arr2 = Array(arr.length); i < arr.length; i++) { arr2[i] = arr[i]; } return arr2; } else { return Array.from(arr); } }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var _class = function () {
  function _class() {
    var _ref = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {},
        _ref$actions = _ref.actions,
        actions = _ref$actions === undefined ? {} : _ref$actions,
        _ref$respond = _ref.respond,
        respond = _ref$respond === undefined ? function () /* res, req */{} : _ref$respond,
        _ref$respondWithError = _ref.respondWithError,
        respondWithError = _ref$respondWithError === undefined ? function () /* err, req */{} : _ref$respondWithError,
        _ref$filter = _ref.filter,
        filter = _ref$filter === undefined ? function () {
      return true;
    } : _ref$filter,
        _ref$transform = _ref.transform,
        transform = _ref$transform === undefined ? function (r) {
      return r;
    } : _ref$transform,
        errorLogger = _ref.errorLogger,
        _ref$onTerminate = _ref.onTerminate,
        onTerminate = _ref$onTerminate === undefined ? function () {} : _ref$onTerminate;

    _classCallCheck(this, _class);

    this.actions = actions;
    this.onTerminate = onTerminate;
    this.dispatch = this.dispatch.bind(this);
    this.filter = filter;
    this.transform = transform;
    this.respond = respond;
    this.respondWithError = respondWithError;
    this.errorLogger = errorLogger;
  }

  _createClass(_class, [{
    key: 'dispatch',
    value: function dispatch(request) {
      var _this = this;

      if (!this.filter || !this.filter(request)) {
        return false;
      }

      var _transform = this.transform(request),
          _transform$args = _transform.args,
          args = _transform$args === undefined ? [] : _transform$args,
          action = _transform.action;

      if (!(0, _helpers.has)(this.actions, action)) {
        return false;
      }

      var res = void 0;

      try {
        var _actions;

        res = (_actions = this.actions)[action].apply(_actions, _toConsumableArray(args));
      } catch (e) {
        this.respondWithError(e.message, request);
        return true;
      }

      if (!(res instanceof Promise)) {
        res = Promise.resolve(res);
      }

      res.then(function (response) {
        return _this.respond(response, request);
      }, function (error) {
        return _this.respondWithError(error, request);
      });

      return true;
    }
  }, {
    key: 'terminate',
    value: function terminate() {
      this.onTerminate();
    }
  }]);

  return _class;
}();

exports.default = _class;
},{"./helpers":1}],4:[function(require,module,exports){
'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

exports.default = function () {
  function s4() {
    return Math.floor((1 + Math.random()) * 0x10000).toString(16).substring(1);
  }
  return [s4(), s4(), '-', s4(), '-', s4(), '-', s4(), '-', s4(), s4(), s4()].join('');
};
},{}]},{},[2])(2)
});

/***/ }),
/* 10 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (immutable) */ __webpack_exports__["b"] = showDatSecureIcon;
/* unused harmony export showDatAvailableIcon */
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__sites__ = __webpack_require__(8);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__dat_apis__ = __webpack_require__(6);
// detect www sites which publish a dat version
// TODO should probably rely on dat-dns for this.




function init() {
    browser.webRequest.onCompleted.addListener((details) => {
        const host = details.url.split('/')[2];
        __WEBPACK_IMPORTED_MODULE_1__dat_apis__["b" /* default */].DatArchive.resolveName(host).then((wellKnown) => {
            if (wellKnown) {
                showDatAvailableIcon(details.tabId);
            }
        });
    }, {
        urls: ['https://*/*'],
        types: ['main_frame'],
    });
}

function showDatSecureIcon(tabId) {
    browser.pageAction.setIcon({
        tabId,
        path: 'assets/dat-hexagon.svg',
    });
    browser.pageAction.setTitle({
        tabId,
        title: 'Secure Dat Site',
    });
    browser.pageAction.setPopup({ tabId, popup: 'pages/popup.html' });
    browser.pageAction.show(tabId);
}

function showDatAvailableIcon(tabId) {
    browser.pageAction.setIcon({
        tabId,
        path: 'assets/dat-hexagon-blue.svg',
    });
    browser.pageAction.setTitle({
        tabId,
        title: 'Dat Version Available',
    });
    browser.pageAction.setPopup({ tabId, popup: '' });
    browser.pageAction.show(tabId);
}

// Page action for dat enabled sites: reloads the page over dat.
browser.pageAction.onClicked.addListener((tab) => {
    const [protocol, , host] = tab.url.split('/');
    __WEBPACK_IMPORTED_MODULE_1__dat_apis__["b" /* default */].DatArchive.resolveName(host).then((wellKnown) => {
        if (!wellKnown) {
            return;
        }
        // flush browser cache for redirects
        browser.webRequest.handlerBehaviorChanged().then(() => {
            if (protocol === 'https:') {
                // current protocol is https: switch to dat
                console.log(host, 'switch to https');
                browser.tabs.update(tab.id,
                    {
                        url: tab.url.replace('https://', 'dat://'),
                    }
                );
            } else if (protocol === 'http:' && __WEBPACK_IMPORTED_MODULE_0__sites__["b" /* datSites */].has(host)) {
                // already on dat, switch back to http
                console.log(host, 'switch to https');
                __webpack_require__.i(__WEBPACK_IMPORTED_MODULE_0__sites__["c" /* removeDatSite */])(host);
                browser.tabs.update(tab.id,
                    {
                        url: tab.url.replace('http://', 'https://'),
                    }
                );
            }
        });
    });
});

/* harmony default export */ __webpack_exports__["a"] = ({
    init,
});


/***/ }),
/* 11 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";

const dialogs = new Map();

/* harmony default export */ __webpack_exports__["a"] = ({
    async open(message) {
        const win = await browser.windows.create({
            allowScriptsToClose: true,
            type: 'popup',
            url: `/pages/dialog.html#${JSON.stringify(message)}`,
            width: 500,
            height: 400,
        });        
        return new Promise((resolve, reject) => {
            const onWindowRemoved = (windowId) => {
                if (windowId === win.id) {
                    dialogs.delete(message.id);
                    reject('Dialog closed');
                    browser.windows.onRemoved.removeListener(onWindowRemoved);
                }
            };
            browser.windows.onRemoved.addListener(onWindowRemoved);
            const closeWindowWrapper = (cb) => ((...args) => {
                browser.windows.onRemoved.removeListener(onWindowRemoved);
                browser.windows.remove(win.id);
                cb(...args);
            });
            dialogs.set(message.id, {
                resolve: closeWindowWrapper(resolve),
                reject: closeWindowWrapper(reject)
            });
        });
    },
    onMessage({ dialogId, result, error }) {
        if (error) {
            dialogs.get(dialogId).reject(error);
        } else {
            dialogs.get(dialogId).resolve(result);
        }
        dialogs.delete(dialogId);
        return Promise.resolve();
    }
});


/***/ }),
/* 12 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0_spanan__ = __webpack_require__(9);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0_spanan___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_0_spanan__);


function wrapMessage(message) {
    const compatMessage = {
        action: message.action,
        id: message.uuid,
    };
    if (message.args && message.args[0]) {
        const args = message.args[0];
        Object.keys(args).forEach((k) => {
            compatMessage[k] = args[k];
        });
    }
    return compatMessage;
}

function unwrapMessage(message) {
    message.uuid = message.id;
    if (message.result) {
        message.response = message.result;
    } else if (!message.error) {
        message.response = undefined;
    }
    return message;
}

/* harmony default export */ __webpack_exports__["a"] = (class {

    constructor() {
        this.connected = false;
    }

    connect() {
        this.port = browser.runtime.connectNative('dathelper');
        this.messageWrapper = new __WEBPACK_IMPORTED_MODULE_0_spanan___default.a((message) => {
            this.port.postMessage(wrapMessage(message));
        });
        this.port.onMessage.addListener((message) => {
            this.messageWrapper.handleMessage(unwrapMessage(message));
        });
        this.api = this.messageWrapper.createProxy();
        
        return new Promise((resolve, reject) => {
            // wait 2s to see if launch of the subprocess was successful
            const disconnectListener = (p) => {
                clearTimeout(timer);
                reject(p.error);
            };
            const timer = setTimeout(() => {
                this.port.onDisconnect.removeListener(disconnectListener);
                this.connected = true;
                resolve();
            }, 2000);
            this.port.onDisconnect.addListener(disconnectListener);
        });
    }

    disconnect() {
        this.connected = false;
        this.port.disconnect();
    }
});


/***/ }),
/* 13 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__sites__ = __webpack_require__(8);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__page_action__ = __webpack_require__(10);
/**
 * Sets up redirects for dat:// urls to be proxied.
 */



const datUrlMatcher = /^[0-9a-f]{64}(\+[0-9]+)?$/;

function init() {
    /*
    * Listen for requests to a fake redirect host (dat.localhost), and redirect to a url which will be
    * proxied to the dat-gateway.
    */
    browser.webRequest.onBeforeRequest.addListener((details) => {
        // replace url encoded dat:// prefix
        const datUrl = decodeURIComponent(details.url.replace('http://dat.localhost/?dat%3A%2F%2F', ''));
        const hostOrAddress = datUrl.split('/')[0];

        // if its a plain dat url, just do the redirect
        if (datUrlMatcher.test(hostOrAddress)) {
            return {
                redirectUrl: `http://${datUrl}`,
            };
        }
        // otherwise, we need to add this hostname to the list of dat sites
        // TODO this will trigger a race condition
        __webpack_require__.i(__WEBPACK_IMPORTED_MODULE_0__sites__["a" /* addDatSite */])(hostOrAddress);
        return {
            redirectUrl: `http://${datUrl}`,
        };
    }, {
        urls: ['http://dat.localhost/*'],
    }, ['blocking']);

    // trigger dat secure page action for dat pages
    browser.tabs.onUpdated.addListener((tabId, changeInfo) => {
        if (changeInfo.url && changeInfo.url.startsWith('http')) {
            const host = changeInfo.url.split('/')[2];
            if (__WEBPACK_IMPORTED_MODULE_0__sites__["b" /* datSites */].has(host) || datUrlMatcher.test(host)) {
                __webpack_require__.i(__WEBPACK_IMPORTED_MODULE_1__page_action__["b" /* showDatSecureIcon */])(tabId);
            }
        }
    });
}

/* harmony default export */ __webpack_exports__["a"] = ({
    init,
});


/***/ }),
/* 14 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__proxy__ = __webpack_require__(7);
/**
 * Handles persistent user settings. These are
 *  * user configured gateway address
 */


/* harmony default export */ __webpack_exports__["a"] = ({
    load() {
        // read settings for gateway
        browser.storage.local.get('gatewayAddress').then((res) => {
            if (res.gatewayAddress) {
                __webpack_require__.i(__WEBPACK_IMPORTED_MODULE_0__proxy__["b" /* setGatewayAddress */])(res.gatewayAddress);
            }
        });

        browser.storage.onChanged.addListener((changes, areaName) => {
            if (areaName === 'local' && changes.gatewayAddress) {
                __webpack_require__.i(__WEBPACK_IMPORTED_MODULE_0__proxy__["b" /* setGatewayAddress */])(changes.gatewayAddress.newValue);
            }
        });
    }
});


/***/ }),
/* 15 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
Object.defineProperty(__webpack_exports__, "__esModule", { value: true });
/* WEBPACK VAR INJECTION */(function(global) {/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__proxy__ = __webpack_require__(7);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__settings__ = __webpack_require__(14);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__protocol__ = __webpack_require__(13);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__page_action__ = __webpack_require__(10);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__native_bridge__ = __webpack_require__(12);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5__dat_apis__ = __webpack_require__(6);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_6__sites__ = __webpack_require__(8);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_7__dialog__ = __webpack_require__(11);









// initialise proxy pac file
__WEBPACK_IMPORTED_MODULE_0__proxy__["a" /* proxyReady */].then(() => {
    // get gatewayaddress from settings
    __WEBPACK_IMPORTED_MODULE_1__settings__["a" /* default */].load();
    // register listeners for urls which should be handled by the dat protocol
    __WEBPACK_IMPORTED_MODULE_2__protocol__["a" /* default */].init();
    __WEBPACK_IMPORTED_MODULE_3__page_action__["a" /* default */].init();
});

const bridge = new __WEBPACK_IMPORTED_MODULE_4__native_bridge__["a" /* default */]();
global.bridge = bridge;
global.resetBridge = async () => {
    if (bridge.connected) {
        bridge.disconnect();
    }
    await bridge.connect();
    console.log('bridge is ready');
    __webpack_require__.i(__WEBPACK_IMPORTED_MODULE_5__dat_apis__["a" /* useNativeBridge */])(bridge.api);
    const port = 3000 + Math.floor(Math.random() * 500);
    await bridge.api.startGateway({ port });
    __webpack_require__.i(__WEBPACK_IMPORTED_MODULE_0__proxy__["b" /* setGatewayAddress */])(`http://localhost:${port}`);
    // add actions which the helper API supports
    ['resolveName', 'getInfo', 'stat', 'readdir', 'history', 'readFile', 'writeFile', 'mkdir', 
        'unlink', 'rmdir', 'diff', 'commit', 'revert', 'download', 'createFileActivityStream',
        'createNetworkActivityStream', 'pollActivityStream', 'closeActivityStream', 'configure',
        'copy', 'rename']
        .forEach((action) => {
            passthroughActions.add(action);
        });
    // manage open archives
    setInterval(async () => {
        const library = new Set((await bridge.api.listLibrary()).map(({ url }) => url));
        const archives = await bridge.api.getOpenArchives();
        // 5 mins inactivity -> close
        const ageCutoff = Date.now() - (5 * 60 * 1000);
        const closeArchives = archives.filter(({ url, lastUsed }) => !library.has(url) && lastUsed < ageCutoff);
        if (closeArchives.length > 0) {
            console.log('closing dats:', closeArchives.map(({ url }) => url));
            await closeArchives.map(({ url }) => bridge.api.closeArchive({ url }));
        }
    }, 60000);
    return port;
};

global.resetBridge().catch((e) => {
    console.log('bridge loading failed, using local Dat API implementation', e);
    console.log('opening setup page');
    browser.tabs.create({ url: browser.extension.getURL('pages/setup.html')});
});


// actions in this set are forwarded to the native bridge
const passthroughActions = new Set();

// local handlers for actions from content script
const handlers = {
    resolveName: (message) => __WEBPACK_IMPORTED_MODULE_5__dat_apis__["b" /* default */].DatArchive.resolveName(message.name),
    addDatSite: (message) => __webpack_require__.i(__WEBPACK_IMPORTED_MODULE_6__sites__["a" /* addDatSite */])(message.host),
    create: (message) => __WEBPACK_IMPORTED_MODULE_7__dialog__["a" /* default */].open(message),
    fork: (message) => __WEBPACK_IMPORTED_MODULE_7__dialog__["a" /* default */].open(message),
    selectArchive: (message) => __WEBPACK_IMPORTED_MODULE_7__dialog__["a" /* default */].open(message),
    dialogResponse: (message) => __WEBPACK_IMPORTED_MODULE_7__dialog__["a" /* default */].onMessage(message),
};

browser.runtime.onConnect.addListener((port) => {
    port.onMessage.addListener((message) => {
        const { uuid, action, args } = message;
        if (passthroughActions.has(action)) {
            bridge.api[action](...args).then(
                response => ({ uuid, action, response }),
                error => ({ uuid, action, error })
            ).then(response => {
                port.postMessage(response);
            });
        } else if (handlers[action]) {
            handlers[action](message).then((response) => {
                port.postMessage({
                    uuid,
                    action,
                    response,
                });
            }, (error) => {
                port.postMessage({
                    uuid,
                    action,
                    error: error,
                });
            });
        } else {
            port.postMessage({
                uuid,
                error: 'unsupported action',
            });
        }
    });
});

/* WEBPACK VAR INJECTION */}.call(__webpack_exports__, __webpack_require__(2)))

/***/ }),
/* 16 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__dat_dns__ = __webpack_require__(17);


class DatArchive {
    constructor(datUrl) {
        this.url = datUrl;
    }

    static resolveName(name) {
        return __webpack_require__.i(__WEBPACK_IMPORTED_MODULE_0__dat_dns__["a" /* resolveName */])(name);
    }
}
/* harmony export (immutable) */ __webpack_exports__["a"] = DatArchive;



/***/ }),
/* 17 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (immutable) */ __webpack_exports__["a"] = resolveName;

const wellKnownCache = new Map();

// TODO: see if we can browserify dat-dns
function resolveName(host) {
    return new Promise((resolve, reject) => {
        if (wellKnownCache.has(host)) {
            resolve(Promise.resolve(wellKnownCache.get(host)));
        }
        fetch(`https://${host}/.well-known/dat`, { redirect: 'manual' }).then((resp) => {
            if (resp.ok) {
                return resp.text().then(text => {
                    try {
                        return /^dat:\/\/([0-9a-f]{64})/i.exec(text.split('/n')[0])[1];
                    } catch(e) {
                        return false;
                    }
                });
            }
            return false;
        }).then((address) => {
            wellKnownCache.set(host, address);
            if (!address) {
                reject();
                return;
            }
            resolve(address);
        });
    });
}

/***/ })
/******/ ]);